Subject: Re: bug#16641: Assert triggered (hashtab.c:137) - Guile-2.0.9

From: Andy Wingo <[email-masked]>
Date: Tue, 21 Jun 2016 14:58:17 +0200

On Wed 05 Feb 2014 16:56, Mark H Weaver <[email-masked]> writes:

> Also: this is on Solaris 10u10.  Cole mentioned that on IRC.

On the one hand I don't understand how this can happen.  On the other, I
unfortunately don't have faith in the buckets-and-chains weak table
implementation in 2.0; it usually works but it's gnarly and is a
threading nightmare, and accesses disappearing links outside the alloc
lock.  See for example:

  http://article.gmane.org/gmane.comp.programming.garbage-collection.boehmgc/4789

In 2.2 the weak table is rewritten to not require the "vacuum" phase and
to be threadsafe.  That was my best effort at fixing this bug but I
couldn't do it with some of the constraints in 2.0.  For that reason I
am closing this one but feel free to re-open it if you find available
hackpower to work towards a solution for 2.0.

Andy